<?php

# Includes
include('/home/admin/lib/php/beroGui.class.php');

# Define functions below this line.
# Define functions above this line.

# Session-Management
require_once('/home/admin/lib/php/session.php');

function getAppFsVersion () {
	$versionFile = file_get_contents('/usr/local/VERSION');

	preg_match('/APPFS=([0-9]*)/', $versionFile, $matches);

	return($matches[1]);
}

function getAuthMechanism () {
	return(strstr(file_get_contents('/etc/lighttpd.conf'), 'auth.backend = "plain"') ? 'plain' : 'htpasswd');
}

function displayTable () {
	$ret =	'<form method="POST">' . "\n" .
		'<table class="contenttoc" style="width: 300px; margin-right: auto; margin-left: auto;">' . "\n" .
		'<tr><th>Change Authentication-Mechanism for API</th></tr>' . "\n" .
		'<tr><td><input type="submit" name="submit" value="Change Auth-Mechanism back to \'plain\'" ' .
			'onclick="return confirm(\'Performing this action will reboot this Gateway. Do you want to continue?\');" /></td></tr>' . "\n" .
		'</table>' . "\n" .
		'</form>' . "\n";

	return($ret);
}

function changeMechanism () {
	exec('/bin/mount -oremount,rw /');
	exec('/bin/sed -i \'s/htpasswd/plain/g\' /etc/lighttpd.conf');
	exec('/bin/rm -rf /pkginfo');
	file_put_contents('/usr/conf/apiusers.conf', "admin:admin\n");
	exec('/bin/mount -oremount,ro /');
	exec('/sbin/reboot');
}

if (isset($_POST['submit'])) {
	changeMechanism();
	header('Location: /app/berogui/includes/login.php');
	exit(0);
}

# Name of your app:
$app_name = 'ApiAuthSwitch';

$currentMechanism = getAuthMechanism();
$appFsVersion = getAppFsVersion();

# beroNet GUI
$app_gui = new beroGUIv2($app_name);

$body =		$app_gui->get_MainHeader(array(), '') .
		'<div style="text-align: center;">' . "\n" .
		'The purpose of this app is to revert the change of the authentication-mechanism, which is performed by installing Firmware-Version 3.x or newer.<br /><br />' .
		'<b>It is only usable on Gateways that have been updated to 3.x or newer at first and downgraded to 2.x or older afterwards.</b><br /><br />' .
		'Reverting the authentication-mechanism also sets the password for the API-user to <b>admin</b> and <b>initiates a reboot</b> of this Gateway.<br /><br />' .
		(($appFsVersion >= 3) ? '<span style="font-weight: bold; color: red;">This app is only designed for Firmware-Versions 2.x and older!</span>' :
			(($currentMechanism == 'plain') ? '<span style="font-weight: bold; color: red;">API-Authentication-Mechanism is already \'plain\'. It is safe to uninstall this app.</span>' :
			displayTable())) .
		'</div>' . "\n" .
		$app_gui->get_MainFooter();

echo $body;
?>
